(defun Test_Param (sec stri def / i i1) ; , , __

  (defun vl_string_position (ch str / pos c)
    (setq 
      pos 1
      ch (substr ch 1 1)
    )
    (while (and
	     (/= ch (setq c (substr str pos 1)))
	     (/= c "")
  	   ) ;_ end of and
      (setq pos (1+ pos))
    )
    (if (/= c "")
      pos
      nil
    )
  )

  ;;--------------------------------------------------------------------------
  ;;     INI    
  ;; (SecPos _ _)
  ;;       NIL    .
  ;; Copyright DataCAD Group 1995-2000 .
  ;;--------------------------------------------------------------------------
  (defun secpos (df sec / fl cline n)
    (setq fl t
 	  sec (strcase sec nil)
	  n 1
    ) ;_ end of setq
    (while fl
      (setq cline (read-line df)
	    n (1+ n)
      ) ;_ end of setq
      (cond
        ((not cline)			;  ?
         (setq fl nil			;   !
	       n nil
         ) ;_ end of setq
        )
        ((= "[" (substr cline 1 1)) 	; ! -  !
         (if (= sec			;   ?
	        (strcase
				;  VDE69 --------------------->
			(substr cline
	           		(+ (vl_string_position "[" cline) 2)
		   		   (if (= nil (vl_string_position "]" cline))
				     (- (strlen cline))
				     (- (vl_string_position "]" cline) 1)))
			        ; <----------------------  VDE69
		  nil
	        ) ;_ end of strcase
	     ) ;_ end of =
  	   (setq fl nil)		; ! ...
	   (setq fl t)			;  -  .
         ) ;_ end of if
        )
        (t				;      ! - ...
         (setq fl t)
        )
      )
    )
    n
  ) 
  ; ---------------------------------------------------------------------

  ;;--------------------------------------------------------------------------
  ;;      INI 
  ;; (VarGet _ _)
  ;;   -    NIL   .
  ;; Copyright DataCAD Group 1995-2000 .
  ;;--------------------------------------------------------------------------
  (defun varget (df var / fl res cline)
    (setq fl  t
  	  res nil
	  var (strcase var nil)
    ) ;_ end of setq
    (while fl
      (setq cline (read-line df))
      (cond
        ((not cline)			;   ?
         (setq fl nil)
        )
        ((= "[" (substr cline 1 1)) 	;  
         (setq fl nil)			;  
        )
					;  VDE69 --------------------->
					; ,      ?
        ((= var (strcase (substr cline 1 (vl_string_position "=" cline)) nil))
					; ! ,   ...
           (setq res (substr cline
			    (+ (vl_string_position "=" cline) 2)
			    (- (strlen cline) (vl_string_position "=" cline) 1)))
        )				; <----------------------  VDE69 
        (t
         (setq fl t)
        )
      ) ;_ end of cond
    ) ;_ end of while
    res
  ) ;_ end of defun
  ; ---------------------------------------------------------------------
  
  (setq i (findfile "Set_Param.dat")
	i1 nil)
  (if (= i nil)
    (princ "\n  ")
    (progn
      (setq i (open i "r"))
      (if (secpos i sec)		
	(setq i1 (varget i stri)))
      (setq i (close i))
    ))
  (if (= i1 nil) (eval def) (eval i1))  ;   
)

(defun Get_Setup () ;  
  (setq F_Setup 
    (list
	(getvar "OSMODE")
	(getvar "BLIPMODE")
	(getvar "CMDECHO")
	(getvar "CECOLOR")
	(getvar "CELTYPE")
	(getvar "CELWEIGHT")
	(getvar "CLAYER")
	(getvar "DRAGMODE")
	(getvar "PLINEWID")
	(getvar "TEXTSTYLE")
	(getvar "TEXTSIZE")
	(getvar "THICKNESS")
  ))
)

(defun Set_Setup () ;  
  (setvar "OSMODE" (nth 0 F_Setup))
  (setvar "BLIPMODE" (nth 1 F_Setup))
  (setvar "CMDECHO" (nth 2 F_Setup))
  (setvar "CECOLOR" (nth 3 F_Setup))
  (setvar "CELTYPE" (nth 4 F_Setup))
  (setvar "CELWEIGHT" (nth 5 F_Setup))
  (setvar "CLAYER" (nth 6 F_Setup))
  (setvar "DRAGMODE" (nth 7 F_Setup))
  (setvar "PLINEWID" (nth 8 F_Setup))
  (setvar "TEXTSTYLE" (nth 9 F_Setup))
  (setvar "TEXTSIZE" (nth 10 F_Setup))
  (setvar "THICKNESS" (nth 11 F_Setup))
)

(defun Set_Layer (s) ;  
  (if (/= (tblsearch "Layer" s) nil)
    (command "_'layer" "s" s "")
    (command "_'layer" "n" s "s" s ""))
)

(defun Name_Menu () ;    
  (Test_Param "Setup" "Menu_Name" "LIB_M")
)

(defun Set_Line_Osn () ;       
  (Set_Layer (Test_Param "Set_out" "Set_Line_Osn_Layer" "0"))
  (command "_linetype" "s" (Test_Param "Set_out" "Set_Line_Osn_Linetype" "bylayer") "")
  (command "_color" (Test_Param "Set_out" "Set_Line_Osn_Color" "bylayer"))
)

(defun Set_Line_Ton () ;       
  (Set_Layer (Test_Param "Set_out" "Set_Line_Ton_Layer" "0"))
  (command "_linetype" "s" (Test_Param "Set_out" "Set_Line_Ton_Linetype" "bylayer") "")
  (command "_color" (Test_Param "Set_out" "Set_Line_Ton_Color" "252"))
)

(defun Set_Line_axis () ;       
  (Set_Layer (Test_Param "Set_out" "Set_Line_Axis_Layer" "0"))
  (command "_linetype" "s" (Test_Param "Set_out" "Set_Line_Axis_Linetype" "center") "")
  (command "_color" (Test_Param "Set_out" "Set_Line_Axis_Color" "2"))
)

(defun Set_Dim_Line () ;      
  (Set_Layer (Test_Param "Set_out" "Set_Line_Dim_Layer" "0"))
  (command "_linetype" "s" (Test_Param "Set_out" "Set_Line_Dim_Linetype" "bylayer") "")
  (command "_color" (Test_Param "Set_out" "Set_Line_Dim_Color" "bylayer"))
)

(defun Set_Dim_Text () ;      
  (command "_style" (Test_Param "Set_out" "Set_Dim_Text_Style" "Standart")
  		    (Test_Param "Set_out" "Set_Dim_Text_Font" "txt") 
  		    (Test_Param "Set_out" "Set_Dim_Text_Height" "0")
  		    (Test_Param "Set_out" "Set_Dim_Text_Width" "1") "0" "N" "N" "N")
)

(defun Set_Text () ;      
  (Set_Layer (Test_Param "Set_out" "Set_Text_Layer" "0"))
  (command "_linetype" "s" (Test_Param "Set_out" "Set_Text_Linetype" "bylayer") "")
  (command "_color" (Test_Param "Set_out" "Set_Text_Color" "bylayer"))
  (command "_style" (Test_Param "Set_out" "Set_Text_Style" "Standart")
  		    (Test_Param "Set_out" "Set_Text_Font" "txt") 
  		    (Test_Param "Set_out" "Set_Text_Height" "0")
  		    (Test_Param "Set_out" "Set_Text_Width" "1") "0" "N" "N" "N")
)

(defun *error* (s)
   (princ s)
   (if (/= Set_Setup nil) 
      (progn
        (princ "\n \n")
        (Set_Setup)
   ))
   (princ)
)
